/* (c) Copyright 2003 Hewlett-Packard Company, all rights reserved.
  [See end of file]
  $Id: Grammar.java,v 1.5 2003/12/13 21:14:33 jeremy_carroll Exp $
*/
package owlcompiler;
import com.hp.hpl.jena.ontology.tidy.impl.*;
import java.util.Arrays;
class Grammar implements Constants {
    static final int orphan = 1;
    static final int notype = 2;
    static final int cyclicRest = 3;
    static final int cyclicFirst = 4;
    static final int badRestriction = 5;
    static final int annotationPropID = 6;
    static final int badID = 7;
    static final int classID = 8;
    static final int dataAnnotationPropID = 9;
    static final int dataPropID = 10;
    static final int dataRangeID = 11;
    static final int datatypeID = 12;
    static final int dlInteger = 13;
    static final int individualID = 14;
    static final int liteInteger = 15;
    static final int literal = 16;
    static final int objectPropID = 17;
    static final int ontologyID = 18;
    static final int ontologyPropertyID = 19;
    static final int transitivePropID = 20;
    static final int unnamedIndividual = 21;
    static final int unnamedOntology = 22;
    static final int userTypedLiteral = 23;
    static final int allDifferent = 24;
    static final int description5disjointWith = 25;
    static final int description5equivalentClass = 26;
    static final int description5object = 27;
    static final int description5subClassOf = 28;
    static final int listOfDataLiteral = 29;
    static final int listOfDescription = 30;
    static final int listOfIndividualID = 31;
    static final int restriction6disjointWith = 32;
    static final int restriction6equivalentClass = 33;
    static final int restriction6object = 34;
    static final int restriction6subClassOf = 35;
    static final int restriction7disjointWith = 36;
    static final int restriction7equivalentClass = 37;
    static final int restriction7object = 38;
    static final int restriction7subClassOf = 39;
    static final int restriction8disjointWith = 40;
    static final int restriction8equivalentClass = 41;
    static final int restriction8object = 42;
    static final int restriction8subClassOf = 43;
    static final int unnamedDataRange = 44;
    static final int owlAllDifferent = 45;
    static final int owlAnnotationProperty = 46;
    static final int owlClass = 47;
    static final int owlDataRange = 48;
    static final int owlDatatypeProperty = 49;
    static final int owlDeprecatedClass = 50;
    static final int owlDeprecatedProperty = 51;
    static final int owlFunctionalProperty = 52;
    static final int owlInverseFunctionalProperty = 53;
    static final int owlObjectProperty = 54;
    static final int owlOntology = 55;
    static final int owlOntologyProperty = 56;
    static final int owlRestriction = 57;
    static final int owlSymmetricProperty = 58;
    static final int owlTransitiveProperty = 59;
    static final int owlcomplementOf = 60;
    static final int owldifferentFrom = 61;
    static final int owldisjointWith = 62;
    static final int owldistinctMembers = 63;
    static final int owlequivalentClass = 64;
    static final int owlequivalentProperty = 65;
    static final int owlhasValue = 66;
    static final int owlintersectionOf = 67;
    static final int owlinverseOf = 68;
    static final int owlmaxCardinality = 69;
    static final int owlonProperty = 70;
    static final int owloneOf = 71;
    static final int owlsameAs = 72;
    static final int owlsomeValuesFrom = 73;
    static final int owlunionOf = 74;
    static final int rdfList = 75;
    static final int rdfProperty = 76;
    static final int rdffirst = 77;
    static final int rdfnil = 78;
    static final int rdfrest = 79;
    static final int rdftype = 80;
    static final int rdfsClass = 81;
    static final int rdfsDatatype = 82;
    static final int rdfsdomain = 83;
    static final int rdfsrange = 84;
    static final int rdfssubClassOf = 85;
    static final int rdfssubPropertyOf = 86;
 static String catNames[] = { "--not used--",
      "orphan",
      "notype",
      "cyclicRest",
      "cyclicFirst",
      "badRestriction",
      "annotationPropID",
      "badID",
      "classID",
      "dataAnnotationPropID",
      "dataPropID",
      "dataRangeID",
      "datatypeID",
      "dlInteger",
      "individualID",
      "liteInteger",
      "literal",
      "objectPropID",
      "ontologyID",
      "ontologyPropertyID",
      "transitivePropID",
      "unnamedIndividual",
      "unnamedOntology",
      "userTypedLiteral",
      "allDifferent",
      "description5disjointWith",
      "description5equivalentClass",
      "description5object",
      "description5subClassOf",
      "listOfDataLiteral",
      "listOfDescription",
      "listOfIndividualID",
      "restriction6disjointWith",
      "restriction6equivalentClass",
      "restriction6object",
      "restriction6subClassOf",
      "restriction7disjointWith",
      "restriction7equivalentClass",
      "restriction7object",
      "restriction7subClassOf",
      "restriction8disjointWith",
      "restriction8equivalentClass",
      "restriction8object",
      "restriction8subClassOf",
      "unnamedDataRange",
      "owlAllDifferent",
      "owlAnnotationProperty",
      "owlClass",
      "owlDataRange",
      "owlDatatypeProperty",
      "owlDeprecatedClass",
      "owlDeprecatedProperty",
      "owlFunctionalProperty",
      "owlInverseFunctionalProperty",
      "owlObjectProperty",
      "owlOntology",
      "owlOntologyProperty",
      "owlRestriction",
      "owlSymmetricProperty",
      "owlTransitiveProperty",
      "owlcomplementOf",
      "owldifferentFrom",
      "owldisjointWith",
      "owldistinctMembers",
      "owlequivalentClass",
      "owlequivalentProperty",
      "owlhasValue",
      "owlintersectionOf",
      "owlinverseOf",
      "owlmaxCardinality",
      "owlonProperty",
      "owloneOf",
      "owlsameAs",
      "owlsomeValuesFrom",
      "owlunionOf",
      "rdfList",
      "rdfProperty",
      "rdffirst",
      "rdfnil",
      "rdfrest",
      "rdftype",
      "rdfsClass",
      "rdfsDatatype",
      "rdfsdomain",
      "rdfsrange",
      "rdfssubClassOf",
      "rdfssubPropertyOf",
       };
static int getBuiltinID(String uri) {
  if ( uri.startsWith("http://www.w3.org/") ) {
      uri = uri.substring(18);
      if (false) {}
   else if ( uri.startsWith("2002/07/owl#") ) {
       uri = uri.substring(12);
       if (false) {
       } else if ( uri.equals("Thing") ) {
          return classID
;
       } else if ( uri.equals("Nothing") ) {
          return classID
;
       } else if ( uri.equals("versionInfo") ) {
          return annotationPropID
;
       } else if ( uri.equals("imports") ) {
          return ontologyPropertyID
;
       } else if ( uri.equals("priorVersion") ) {
          return ontologyPropertyID
;
       } else if ( uri.equals("backwardCompatibleWith") ) {
          return ontologyPropertyID
;
       } else if ( uri.equals("incompatibleWith") ) {
          return ontologyPropertyID
;
       } else if ( uri.equals("Ontology") ) {
          return owlOntology
;
       } else if ( uri.equals("ObjectProperty") ) {
          return owlObjectProperty
;
       } else if ( uri.equals("DataRange") ) {
          return owlDataRange
;
       } else if ( uri.equals("DatatypeProperty") ) {
          return owlDatatypeProperty
;
       } else if ( uri.equals("equivalentClass") ) {
          return owlequivalentClass
;
       } else if ( uri.equals("sameAs") ) {
          return owlsameAs
;
       } else if ( uri.equals("equivalentProperty") ) {
          return owlequivalentProperty
;
       } else if ( uri.equals("Class") ) {
          return owlClass
;
       } else if ( uri.equals("intersectionOf") ) {
          return owlintersectionOf
;
       } else if ( uri.equals("unionOf") ) {
          return owlunionOf
;
       } else if ( uri.equals("complementOf") ) {
          return owlcomplementOf
;
       } else if ( uri.equals("Restriction") ) {
          return owlRestriction
;
       } else if ( uri.equals("onProperty") ) {
          return owlonProperty
;
       } else if ( uri.equals("allValuesFrom") ) {
          return owlsomeValuesFrom
;
       } else if ( uri.equals("someValuesFrom") ) {
          return owlsomeValuesFrom
;
       } else if ( uri.equals("cardinality") ) {
          return owlmaxCardinality
;
       } else if ( uri.equals("minCardinality") ) {
          return owlmaxCardinality
;
       } else if ( uri.equals("maxCardinality") ) {
          return owlmaxCardinality
;
       } else if ( uri.equals("hasValue") ) {
          return owlhasValue
;
       } else if ( uri.equals("OntologyProperty") ) {
          return owlOntologyProperty
;
       } else if ( uri.equals("AllDifferent") ) {
          return owlAllDifferent
;
       } else if ( uri.equals("distinctMembers") ) {
          return owldistinctMembers
;
       } else if ( uri.equals("AnnotationProperty") ) {
          return owlAnnotationProperty
;
       } else if ( uri.equals("FunctionalProperty") ) {
          return owlFunctionalProperty
;
       } else if ( uri.equals("InverseFunctionalProperty") ) {
          return owlInverseFunctionalProperty
;
       } else if ( uri.equals("SymmetricProperty") ) {
          return owlSymmetricProperty
;
       } else if ( uri.equals("TransitiveProperty") ) {
          return owlTransitiveProperty
;
       } else if ( uri.equals("DeprecatedProperty") ) {
          return owlDeprecatedProperty
;
       } else if ( uri.equals("DeprecatedClass") ) {
          return owlDeprecatedClass
;
       } else if ( uri.equals("inverseOf") ) {
          return owlinverseOf
;
       } else if ( uri.equals("oneOf") ) {
          return owloneOf
;
       } else if ( uri.equals("differentFrom") ) {
          return owldifferentFrom
;
       } else if ( uri.equals("disjointWith") ) {
          return owldisjointWith
;
       } else if ( uri.equals("AllDifferent") ) {
          return owlAllDifferent
;
       } else if ( uri.equals("distinctMembers") ) {
          return owldistinctMembers
;
       } else { return BadOWL; 
     }
   }
   else if ( uri.startsWith("1999/02/22-rdf-syntax-ns#") ) {
       uri = uri.substring(25);
       if (false) {
       } else if ( uri.equals("XMLLiteral") ) {
          return datatypeID
;
       } else if ( uri.equals("Bag") ) {
          return classOnly
;
       } else if ( uri.equals("Seq") ) {
          return classOnly
;
       } else if ( uri.equals("Alt") ) {
          return classOnly
;
       } else if ( uri.equals("Statement") ) {
          return classOnly
;
       } else if ( uri.equals("subject") ) {
          return propertyOnly
;
       } else if ( uri.equals("predicate") ) {
          return propertyOnly
;
       } else if ( uri.equals("object") ) {
          return propertyOnly
;
       } else if ( uri.equals("type") ) {
          return rdftype
;
       } else if ( uri.equals("Property") ) {
          return rdfProperty
;
       } else if ( uri.equals("nil") ) {
          return rdfnil
;
       } else if ( uri.equals("first") ) {
          return rdffirst
;
       } else if ( uri.equals("rest") ) {
          return rdfrest
;
       } else if ( uri.equals("List") ) {
          return rdfList
;
       } else { return BadRDF; 
     }
   }
   else if ( uri.startsWith("2001/XMLSchema#") ) {
       uri = uri.substring(15);
       if (false) {
       } else if ( uri.equals("string") ) {
          return datatypeID
;
       } else if ( uri.equals("boolean") ) {
          return datatypeID
;
       } else if ( uri.equals("decimal") ) {
          return datatypeID
;
       } else if ( uri.equals("float") ) {
          return datatypeID
;
       } else if ( uri.equals("double") ) {
          return datatypeID
;
       } else if ( uri.equals("dateTime") ) {
          return datatypeID
;
       } else if ( uri.equals("time") ) {
          return datatypeID
;
       } else if ( uri.equals("date") ) {
          return datatypeID
;
       } else if ( uri.equals("gYearMonth") ) {
          return datatypeID
;
       } else if ( uri.equals("gYear") ) {
          return datatypeID
;
       } else if ( uri.equals("gMonthDay") ) {
          return datatypeID
;
       } else if ( uri.equals("gDay") ) {
          return datatypeID
;
       } else if ( uri.equals("gMonth") ) {
          return datatypeID
;
       } else if ( uri.equals("hexBinary") ) {
          return datatypeID
;
       } else if ( uri.equals("base64Binary") ) {
          return datatypeID
;
       } else if ( uri.equals("anyURI") ) {
          return datatypeID
;
       } else if ( uri.equals("normalizedString") ) {
          return datatypeID
;
       } else if ( uri.equals("token") ) {
          return datatypeID
;
       } else if ( uri.equals("language") ) {
          return datatypeID
;
       } else if ( uri.equals("NMTOKEN") ) {
          return datatypeID
;
       } else if ( uri.equals("Name") ) {
          return datatypeID
;
       } else if ( uri.equals("NCName") ) {
          return datatypeID
;
       } else if ( uri.equals("integer") ) {
          return datatypeID
;
       } else if ( uri.equals("nonPositiveInteger") ) {
          return datatypeID
;
       } else if ( uri.equals("negativeInteger") ) {
          return datatypeID
;
       } else if ( uri.equals("long") ) {
          return datatypeID
;
       } else if ( uri.equals("int") ) {
          return datatypeID
;
       } else if ( uri.equals("short") ) {
          return datatypeID
;
       } else if ( uri.equals("byte") ) {
          return datatypeID
;
       } else if ( uri.equals("nonNegativeInteger") ) {
          return datatypeID
;
       } else if ( uri.equals("unsignedLong") ) {
          return datatypeID
;
       } else if ( uri.equals("unsignedInt") ) {
          return datatypeID
;
       } else if ( uri.equals("unsignedShort") ) {
          return datatypeID
;
       } else if ( uri.equals("unsignedByte") ) {
          return datatypeID
;
       } else if ( uri.equals("positiveInteger") ) {
          return datatypeID
;
       } else if ( uri.equals("duration") ) {
   return BadXSD;
       } else if ( uri.equals("QName") ) {
   return BadXSD;
       } else if ( uri.equals("ENTITY") ) {
   return BadXSD;
       } else if ( uri.equals("ID") ) {
   return BadXSD;
       } else if ( uri.equals("IDREF") ) {
   return BadXSD;
       } else if ( uri.equals("ENTITIES") ) {
   return BadXSD;
       } else if ( uri.equals("IDREFS") ) {
   return BadXSD;
       } else if ( uri.equals("NOTATION") ) {
   return BadXSD;
       } else if ( uri.equals("NMTOKENS") ) {
   return BadXSD;
     }
   }
   else if ( uri.startsWith("2000/01/rdf-schema#") ) {
       uri = uri.substring(19);
       if (false) {
       } else if ( uri.equals("Literal") ) {
          return dataRangeID
;
       } else if ( uri.equals("comment") ) {
          return dataAnnotationPropID
;
       } else if ( uri.equals("label") ) {
          return dataAnnotationPropID
;
       } else if ( uri.equals("isDefinedBy") ) {
          return annotationPropID
;
       } else if ( uri.equals("seeAlso") ) {
          return annotationPropID
;
       } else if ( uri.equals("Datatype") ) {
          return rdfsDatatype
;
       } else if ( uri.equals("subClassOf") ) {
          return rdfssubClassOf
;
       } else if ( uri.equals("subPropertyOf") ) {
          return rdfssubPropertyOf
;
       } else if ( uri.equals("domain") ) {
          return rdfsdomain
;
       } else if ( uri.equals("range") ) {
          return rdfsrange
;
       } else if ( uri.equals("Class") ) {
          return rdfsClass
;
       } else if ( uri.equals("Resource") ) {
           return badID;
       } else if ( uri.equals("member") ) {
           return badID;
       } else if ( uri.equals("Container") ) {
           return badID;
       } else if ( uri.equals("ContainerMembershipProperty") ) {
           return badID;
       } else { return BadRDF; 
     }
   }
     }
     return Failure; 
}
static final int userIDX[] = new int[]{
annotationPropID,
classID,
dataPropID,
datatypeID,
individualID,
notype,
objectPropID,
ontologyID,
ontologyPropertyID,
transitivePropID,
};
static final int propertyOnlyX[] = new int[]{
annotationPropID,
dataPropID,
notype,
objectPropID,
transitivePropID,
};
static final int classOnlyX[] = new int[]{
classID,
notype,
};
static final int blankX[] = new int[]{
badRestriction,
cyclicFirst,
cyclicRest,
notype,
orphan,
unnamedIndividual,
unnamedOntology,
allDifferent,
description5disjointWith,
description5equivalentClass,
description5object,
description5subClassOf,
listOfDataLiteral,
listOfDescription,
listOfIndividualID,
restriction6disjointWith,
restriction6equivalentClass,
restriction6object,
restriction6subClassOf,
restriction7disjointWith,
restriction7equivalentClass,
restriction7object,
restriction7subClassOf,
restriction8disjointWith,
restriction8equivalentClass,
restriction8object,
restriction8subClassOf,
unnamedDataRange,
};
static final int restrictionsX[] = new int[]{
restriction6disjointWith,
restriction6equivalentClass,
restriction6object,
restriction6subClassOf,
restriction7disjointWith,
restriction7equivalentClass,
restriction7object,
restriction7subClassOf,
restriction8disjointWith,
restriction8equivalentClass,
restriction8object,
restriction8subClassOf,
};
static final int descriptionsX[] = new int[]{
description5disjointWith,
description5equivalentClass,
description5object,
description5subClassOf,
};
static final int listsX[] = new int[]{
listOfDataLiteral,
listOfDescription,
listOfIndividualID,
};
static final int disjointWithX[] = new int[]{
description5disjointWith,
restriction6disjointWith,
restriction7disjointWith,
restriction8disjointWith,
};
static final int MAX_SINGLETON_SET = 87 + 1;
static {
for (int i=0; i<87; i++) {
if ( i != CategorySet.find(new int[]{i},true) )
      System.err.println("initialization problem");
}
};
static final private int SPOA(int s, int p, int o, int a) {
 return (((((s << WW) | p) << WW) | o) << ActionShift ) | a;
}
static final int triples[] = new int[]{
SPOA( ontologyID, rdftype, owlOntology, 0 ),
SPOA( datatypeID, rdftype, rdfsDatatype, 0 ),
SPOA( classID, rdftype, owlClass, 0 ),
SPOA( ontologyPropertyID, rdftype, owlOntologyProperty, 0 ),
SPOA( dataPropID, rdftype, owlDatatypeProperty, 0 ),
SPOA( annotationPropID, rdftype, owlAnnotationProperty, 0 ),
SPOA( dataAnnotationPropID, rdftype, owlAnnotationProperty, 0 ),
SPOA( objectPropID, rdftype, owlObjectProperty, 0 ),
SPOA( transitivePropID, rdftype, owlObjectProperty, 0 ),
SPOA( unnamedOntology, rdftype, owlOntology, 0 ),
SPOA( individualID, rdftype, classID, 0 ),
SPOA( unnamedIndividual, rdftype, classID, 0 ),
SPOA( annotationPropID, rdftype, rdfProperty, 0 ),
SPOA( dataAnnotationPropID, rdftype, rdfProperty, 0 ),
SPOA( ontologyPropertyID, rdftype, rdfProperty, 0 ),
SPOA( classID, rdftype, rdfsClass, 0 ),
SPOA( classID, rdftype, owlDeprecatedClass, 0 ),
SPOA( classID, rdfssubClassOf, classID, 0 ),
SPOA( classID, owlintersectionOf, rdfnil, 0 ),
SPOA( classID, owlequivalentClass, classID, 0 ),
SPOA( classID, owlunionOf, rdfnil, 0|DL ),
SPOA( classID, owlcomplementOf, classID, 0|DL ),
SPOA( classID, owloneOf, rdfnil, 0|DL ),
SPOA( dataPropID, rdftype, rdfProperty, 0 ),
SPOA( dataPropID, rdftype, owlDeprecatedProperty, 0 ),
SPOA( dataPropID, rdfssubPropertyOf, dataPropID, 0 ),
SPOA( dataPropID, rdfsdomain, classID, 0 ),
SPOA( dataPropID, rdfsrange, datatypeID, 0 ),
SPOA( dataPropID, rdfsrange, dataRangeID, 0 ),
SPOA( dataPropID, rdftype, owlFunctionalProperty, 0 ),
SPOA( objectPropID, rdftype, rdfProperty, 0 ),
SPOA( objectPropID, rdftype, owlDeprecatedProperty, 0 ),
SPOA( objectPropID, rdfssubPropertyOf, objectPropID, 0 ),
SPOA( objectPropID, rdfssubPropertyOf, transitivePropID, 0 ),
SPOA( objectPropID, rdfsdomain, classID, 0 ),
SPOA( objectPropID, rdfsrange, classID, 0 ),
SPOA( objectPropID, owlinverseOf, objectPropID, 0 ),
SPOA( objectPropID, rdftype, owlFunctionalProperty, 0 ),
SPOA( objectPropID, rdftype, owlInverseFunctionalProperty, 0 ),
SPOA( objectPropID, rdftype, owlSymmetricProperty, 0 ),
SPOA( transitivePropID, rdftype, rdfProperty, 0 ),
SPOA( transitivePropID, rdftype, owlDeprecatedProperty, 0 ),
SPOA( transitivePropID, rdfssubPropertyOf, transitivePropID, 0 ),
SPOA( transitivePropID, rdfsdomain, classID, 0 ),
SPOA( transitivePropID, rdfsrange, classID, 0 ),
SPOA( transitivePropID, owlinverseOf, transitivePropID, 0 ),
SPOA( transitivePropID, rdftype, owlTransitiveProperty, 0 ),
SPOA( transitivePropID, rdftype, owlSymmetricProperty, 0 ),
SPOA( transitivePropID, owlequivalentProperty, transitivePropID, 0 ),
SPOA( objectPropID, owlequivalentProperty, objectPropID, 0 ),
SPOA( dataPropID, owlequivalentProperty, dataPropID, 0 ),
SPOA( classID, owldisjointWith, classID, 0|DL ),
SPOA( datatypeID, rdftype, owlDeprecatedClass, 0 ),
SPOA( ontologyID, ontologyPropertyID, ontologyID, 0 ),
SPOA( unnamedOntology, ontologyPropertyID, ontologyID, 0 ),
SPOA( ontologyID, annotationPropID, dlInteger, 0 ),
SPOA( ontologyID, annotationPropID, liteInteger, 0 ),
SPOA( ontologyID, annotationPropID, userTypedLiteral, 0 ),
SPOA( ontologyID, annotationPropID, literal, 0 ),
SPOA( unnamedOntology, annotationPropID, dlInteger, 0 ),
SPOA( unnamedOntology, annotationPropID, liteInteger, 0 ),
SPOA( unnamedOntology, annotationPropID, userTypedLiteral, 0 ),
SPOA( unnamedOntology, annotationPropID, literal, 0 ),
SPOA( individualID, annotationPropID, dlInteger, 0 ),
SPOA( individualID, annotationPropID, liteInteger, 0 ),
SPOA( individualID, annotationPropID, userTypedLiteral, 0 ),
SPOA( individualID, annotationPropID, literal, 0 ),
SPOA( unnamedIndividual, annotationPropID, dlInteger, 0 ),
SPOA( unnamedIndividual, annotationPropID, liteInteger, 0 ),
SPOA( unnamedIndividual, annotationPropID, userTypedLiteral, 0 ),
SPOA( unnamedIndividual, annotationPropID, literal, 0 ),
SPOA( annotationPropID, annotationPropID, dlInteger, 0 ),
SPOA( annotationPropID, annotationPropID, liteInteger, 0 ),
SPOA( annotationPropID, annotationPropID, userTypedLiteral, 0 ),
SPOA( annotationPropID, annotationPropID, literal, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, dlInteger, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, liteInteger, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, userTypedLiteral, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, literal, 0 ),
SPOA( ontologyPropertyID, annotationPropID, dlInteger, 0 ),
SPOA( ontologyPropertyID, annotationPropID, liteInteger, 0 ),
SPOA( ontologyPropertyID, annotationPropID, userTypedLiteral, 0 ),
SPOA( ontologyPropertyID, annotationPropID, literal, 0 ),
SPOA( classID, annotationPropID, dlInteger, 0 ),
SPOA( classID, annotationPropID, liteInteger, 0 ),
SPOA( classID, annotationPropID, userTypedLiteral, 0 ),
SPOA( classID, annotationPropID, literal, 0 ),
SPOA( dataPropID, annotationPropID, dlInteger, 0 ),
SPOA( dataPropID, annotationPropID, liteInteger, 0 ),
SPOA( dataPropID, annotationPropID, userTypedLiteral, 0 ),
SPOA( dataPropID, annotationPropID, literal, 0 ),
SPOA( objectPropID, annotationPropID, dlInteger, 0 ),
SPOA( objectPropID, annotationPropID, liteInteger, 0 ),
SPOA( objectPropID, annotationPropID, userTypedLiteral, 0 ),
SPOA( objectPropID, annotationPropID, literal, 0 ),
SPOA( transitivePropID, annotationPropID, dlInteger, 0 ),
SPOA( transitivePropID, annotationPropID, liteInteger, 0 ),
SPOA( transitivePropID, annotationPropID, userTypedLiteral, 0 ),
SPOA( transitivePropID, annotationPropID, literal, 0 ),
SPOA( datatypeID, annotationPropID, dlInteger, 0 ),
SPOA( datatypeID, annotationPropID, liteInteger, 0 ),
SPOA( datatypeID, annotationPropID, userTypedLiteral, 0 ),
SPOA( datatypeID, annotationPropID, literal, 0 ),
SPOA( ontologyID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( ontologyID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( ontologyID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( ontologyID, dataAnnotationPropID, literal, 0 ),
SPOA( unnamedOntology, dataAnnotationPropID, dlInteger, 0 ),
SPOA( unnamedOntology, dataAnnotationPropID, liteInteger, 0 ),
SPOA( unnamedOntology, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( unnamedOntology, dataAnnotationPropID, literal, 0 ),
SPOA( individualID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( individualID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( individualID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( individualID, dataAnnotationPropID, literal, 0 ),
SPOA( unnamedIndividual, dataAnnotationPropID, dlInteger, 0 ),
SPOA( unnamedIndividual, dataAnnotationPropID, liteInteger, 0 ),
SPOA( unnamedIndividual, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( unnamedIndividual, dataAnnotationPropID, literal, 0 ),
SPOA( annotationPropID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( annotationPropID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( annotationPropID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( annotationPropID, dataAnnotationPropID, literal, 0 ),
SPOA( dataAnnotationPropID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( dataAnnotationPropID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( dataAnnotationPropID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( dataAnnotationPropID, dataAnnotationPropID, literal, 0 ),
SPOA( ontologyPropertyID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( ontologyPropertyID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( ontologyPropertyID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( ontologyPropertyID, dataAnnotationPropID, literal, 0 ),
SPOA( classID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( classID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( classID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( classID, dataAnnotationPropID, literal, 0 ),
SPOA( dataPropID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( dataPropID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( dataPropID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( dataPropID, dataAnnotationPropID, literal, 0 ),
SPOA( objectPropID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( objectPropID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( objectPropID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( objectPropID, dataAnnotationPropID, literal, 0 ),
SPOA( transitivePropID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( transitivePropID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( transitivePropID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( transitivePropID, dataAnnotationPropID, literal, 0 ),
SPOA( datatypeID, dataAnnotationPropID, dlInteger, 0 ),
SPOA( datatypeID, dataAnnotationPropID, liteInteger, 0 ),
SPOA( datatypeID, dataAnnotationPropID, userTypedLiteral, 0 ),
SPOA( datatypeID, dataAnnotationPropID, literal, 0 ),
SPOA( ontologyID, annotationPropID, individualID, 0 ),
SPOA( ontologyID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( unnamedOntology, annotationPropID, individualID, 0 ),
SPOA( unnamedOntology, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( individualID, annotationPropID, individualID, 0 ),
SPOA( individualID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( unnamedIndividual, annotationPropID, individualID, 0 ),
SPOA( unnamedIndividual, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( annotationPropID, annotationPropID, individualID, 0 ),
SPOA( annotationPropID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( dataAnnotationPropID, annotationPropID, individualID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( ontologyPropertyID, annotationPropID, individualID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( classID, annotationPropID, individualID, 0 ),
SPOA( classID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( dataPropID, annotationPropID, individualID, 0 ),
SPOA( dataPropID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( objectPropID, annotationPropID, individualID, 0 ),
SPOA( objectPropID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( transitivePropID, annotationPropID, individualID, 0 ),
SPOA( transitivePropID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( datatypeID, annotationPropID, individualID, 0 ),
SPOA( datatypeID, annotationPropID, unnamedIndividual, ObjectAction ),
SPOA( ontologyID, annotationPropID, annotationPropID, 0 ),
SPOA( unnamedOntology, annotationPropID, annotationPropID, 0 ),
SPOA( individualID, annotationPropID, annotationPropID, 0 ),
SPOA( unnamedIndividual, annotationPropID, annotationPropID, 0 ),
SPOA( annotationPropID, annotationPropID, annotationPropID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, annotationPropID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, annotationPropID, 0 ),
SPOA( classID, annotationPropID, annotationPropID, 0 ),
SPOA( dataPropID, annotationPropID, annotationPropID, 0 ),
SPOA( objectPropID, annotationPropID, annotationPropID, 0 ),
SPOA( transitivePropID, annotationPropID, annotationPropID, 0 ),
SPOA( datatypeID, annotationPropID, annotationPropID, 0 ),
SPOA( ontologyID, annotationPropID, badID, 0 ),
SPOA( unnamedOntology, annotationPropID, badID, 0 ),
SPOA( individualID, annotationPropID, badID, 0 ),
SPOA( unnamedIndividual, annotationPropID, badID, 0 ),
SPOA( annotationPropID, annotationPropID, badID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, badID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, badID, 0 ),
SPOA( classID, annotationPropID, badID, 0 ),
SPOA( dataPropID, annotationPropID, badID, 0 ),
SPOA( objectPropID, annotationPropID, badID, 0 ),
SPOA( transitivePropID, annotationPropID, badID, 0 ),
SPOA( datatypeID, annotationPropID, badID, 0 ),
SPOA( ontologyID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( unnamedOntology, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( individualID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( unnamedIndividual, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( annotationPropID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( classID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( dataPropID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( objectPropID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( transitivePropID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( datatypeID, annotationPropID, dataAnnotationPropID, 0 ),
SPOA( ontologyID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( unnamedOntology, annotationPropID, ontologyPropertyID, 0 ),
SPOA( individualID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( unnamedIndividual, annotationPropID, ontologyPropertyID, 0 ),
SPOA( annotationPropID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( classID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( dataPropID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( objectPropID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( transitivePropID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( datatypeID, annotationPropID, ontologyPropertyID, 0 ),
SPOA( ontologyID, annotationPropID, ontologyID, 0 ),
SPOA( unnamedOntology, annotationPropID, ontologyID, 0 ),
SPOA( individualID, annotationPropID, ontologyID, 0 ),
SPOA( unnamedIndividual, annotationPropID, ontologyID, 0 ),
SPOA( annotationPropID, annotationPropID, ontologyID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, ontologyID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, ontologyID, 0 ),
SPOA( classID, annotationPropID, ontologyID, 0 ),
SPOA( dataPropID, annotationPropID, ontologyID, 0 ),
SPOA( objectPropID, annotationPropID, ontologyID, 0 ),
SPOA( transitivePropID, annotationPropID, ontologyID, 0 ),
SPOA( datatypeID, annotationPropID, ontologyID, 0 ),
SPOA( ontologyID, annotationPropID, classID, 0 ),
SPOA( unnamedOntology, annotationPropID, classID, 0 ),
SPOA( individualID, annotationPropID, classID, 0 ),
SPOA( unnamedIndividual, annotationPropID, classID, 0 ),
SPOA( annotationPropID, annotationPropID, classID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, classID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, classID, 0 ),
SPOA( classID, annotationPropID, classID, 0 ),
SPOA( dataPropID, annotationPropID, classID, 0 ),
SPOA( objectPropID, annotationPropID, classID, 0 ),
SPOA( transitivePropID, annotationPropID, classID, 0 ),
SPOA( datatypeID, annotationPropID, classID, 0 ),
SPOA( ontologyID, annotationPropID, dataPropID, 0 ),
SPOA( unnamedOntology, annotationPropID, dataPropID, 0 ),
SPOA( individualID, annotationPropID, dataPropID, 0 ),
SPOA( unnamedIndividual, annotationPropID, dataPropID, 0 ),
SPOA( annotationPropID, annotationPropID, dataPropID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, dataPropID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, dataPropID, 0 ),
SPOA( classID, annotationPropID, dataPropID, 0 ),
SPOA( dataPropID, annotationPropID, dataPropID, 0 ),
SPOA( objectPropID, annotationPropID, dataPropID, 0 ),
SPOA( transitivePropID, annotationPropID, dataPropID, 0 ),
SPOA( datatypeID, annotationPropID, dataPropID, 0 ),
SPOA( ontologyID, annotationPropID, transitivePropID, 0 ),
SPOA( unnamedOntology, annotationPropID, transitivePropID, 0 ),
SPOA( individualID, annotationPropID, transitivePropID, 0 ),
SPOA( unnamedIndividual, annotationPropID, transitivePropID, 0 ),
SPOA( annotationPropID, annotationPropID, transitivePropID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, transitivePropID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, transitivePropID, 0 ),
SPOA( classID, annotationPropID, transitivePropID, 0 ),
SPOA( dataPropID, annotationPropID, transitivePropID, 0 ),
SPOA( objectPropID, annotationPropID, transitivePropID, 0 ),
SPOA( transitivePropID, annotationPropID, transitivePropID, 0 ),
SPOA( datatypeID, annotationPropID, transitivePropID, 0 ),
SPOA( ontologyID, annotationPropID, objectPropID, 0 ),
SPOA( unnamedOntology, annotationPropID, objectPropID, 0 ),
SPOA( individualID, annotationPropID, objectPropID, 0 ),
SPOA( unnamedIndividual, annotationPropID, objectPropID, 0 ),
SPOA( annotationPropID, annotationPropID, objectPropID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, objectPropID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, objectPropID, 0 ),
SPOA( classID, annotationPropID, objectPropID, 0 ),
SPOA( dataPropID, annotationPropID, objectPropID, 0 ),
SPOA( objectPropID, annotationPropID, objectPropID, 0 ),
SPOA( transitivePropID, annotationPropID, objectPropID, 0 ),
SPOA( datatypeID, annotationPropID, objectPropID, 0 ),
SPOA( ontologyID, annotationPropID, datatypeID, 0 ),
SPOA( unnamedOntology, annotationPropID, datatypeID, 0 ),
SPOA( individualID, annotationPropID, datatypeID, 0 ),
SPOA( unnamedIndividual, annotationPropID, datatypeID, 0 ),
SPOA( annotationPropID, annotationPropID, datatypeID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, datatypeID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, datatypeID, 0 ),
SPOA( classID, annotationPropID, datatypeID, 0 ),
SPOA( dataPropID, annotationPropID, datatypeID, 0 ),
SPOA( objectPropID, annotationPropID, datatypeID, 0 ),
SPOA( transitivePropID, annotationPropID, datatypeID, 0 ),
SPOA( datatypeID, annotationPropID, datatypeID, 0 ),
SPOA( ontologyID, annotationPropID, dataRangeID, 0 ),
SPOA( unnamedOntology, annotationPropID, dataRangeID, 0 ),
SPOA( individualID, annotationPropID, dataRangeID, 0 ),
SPOA( unnamedIndividual, annotationPropID, dataRangeID, 0 ),
SPOA( annotationPropID, annotationPropID, dataRangeID, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, dataRangeID, 0 ),
SPOA( ontologyPropertyID, annotationPropID, dataRangeID, 0 ),
SPOA( classID, annotationPropID, dataRangeID, 0 ),
SPOA( dataPropID, annotationPropID, dataRangeID, 0 ),
SPOA( objectPropID, annotationPropID, dataRangeID, 0 ),
SPOA( transitivePropID, annotationPropID, dataRangeID, 0 ),
SPOA( datatypeID, annotationPropID, dataRangeID, 0 ),
SPOA( individualID, objectPropID, individualID, 0 ),
SPOA( individualID, objectPropID, unnamedIndividual, ObjectAction ),
SPOA( unnamedIndividual, objectPropID, individualID, 0 ),
SPOA( unnamedIndividual, objectPropID, unnamedIndividual, ObjectAction ),
SPOA( individualID, transitivePropID, individualID, 0 ),
SPOA( individualID, transitivePropID, unnamedIndividual, ObjectAction ),
SPOA( unnamedIndividual, transitivePropID, individualID, 0 ),
SPOA( unnamedIndividual, transitivePropID, unnamedIndividual, ObjectAction ),
SPOA( individualID, dataPropID, dlInteger, 0 ),
SPOA( individualID, dataPropID, liteInteger, 0 ),
SPOA( individualID, dataPropID, userTypedLiteral, 0 ),
SPOA( individualID, dataPropID, literal, 0 ),
SPOA( unnamedIndividual, dataPropID, dlInteger, 0 ),
SPOA( unnamedIndividual, dataPropID, liteInteger, 0 ),
SPOA( unnamedIndividual, dataPropID, userTypedLiteral, 0 ),
SPOA( unnamedIndividual, dataPropID, literal, 0 ),
SPOA( individualID, owlsameAs, individualID, 0 ),
SPOA( individualID, owldifferentFrom, individualID, 0 ),
SPOA( ontologyID, annotationPropID, owlAllDifferent, 0 ),
SPOA( unnamedOntology, annotationPropID, owlAllDifferent, 0 ),
SPOA( individualID, annotationPropID, owlAllDifferent, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlAllDifferent, 0 ),
SPOA( annotationPropID, annotationPropID, owlAllDifferent, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlAllDifferent, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlAllDifferent, 0 ),
SPOA( classID, annotationPropID, owlAllDifferent, 0 ),
SPOA( dataPropID, annotationPropID, owlAllDifferent, 0 ),
SPOA( objectPropID, annotationPropID, owlAllDifferent, 0 ),
SPOA( transitivePropID, annotationPropID, owlAllDifferent, 0 ),
SPOA( datatypeID, annotationPropID, owlAllDifferent, 0 ),
SPOA( ontologyID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( individualID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( classID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlAnnotationProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlClass, 0 ),
SPOA( unnamedOntology, annotationPropID, owlClass, 0 ),
SPOA( individualID, annotationPropID, owlClass, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlClass, 0 ),
SPOA( annotationPropID, annotationPropID, owlClass, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlClass, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlClass, 0 ),
SPOA( classID, annotationPropID, owlClass, 0 ),
SPOA( dataPropID, annotationPropID, owlClass, 0 ),
SPOA( objectPropID, annotationPropID, owlClass, 0 ),
SPOA( transitivePropID, annotationPropID, owlClass, 0 ),
SPOA( datatypeID, annotationPropID, owlClass, 0 ),
SPOA( ontologyID, annotationPropID, owlDataRange, 0 ),
SPOA( unnamedOntology, annotationPropID, owlDataRange, 0 ),
SPOA( individualID, annotationPropID, owlDataRange, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlDataRange, 0 ),
SPOA( annotationPropID, annotationPropID, owlDataRange, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlDataRange, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlDataRange, 0 ),
SPOA( classID, annotationPropID, owlDataRange, 0 ),
SPOA( dataPropID, annotationPropID, owlDataRange, 0 ),
SPOA( objectPropID, annotationPropID, owlDataRange, 0 ),
SPOA( transitivePropID, annotationPropID, owlDataRange, 0 ),
SPOA( datatypeID, annotationPropID, owlDataRange, 0 ),
SPOA( ontologyID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( individualID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( classID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlDatatypeProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( unnamedOntology, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( individualID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( annotationPropID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( classID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( dataPropID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( objectPropID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( transitivePropID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( datatypeID, annotationPropID, owlDeprecatedClass, 0 ),
SPOA( ontologyID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( individualID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( classID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlDeprecatedProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( individualID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( classID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlFunctionalProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( individualID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( classID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlInverseFunctionalProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlObjectProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlObjectProperty, 0 ),
SPOA( individualID, annotationPropID, owlObjectProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlObjectProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlObjectProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlObjectProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlObjectProperty, 0 ),
SPOA( classID, annotationPropID, owlObjectProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlObjectProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlObjectProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlObjectProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlObjectProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlOntology, 0 ),
SPOA( unnamedOntology, annotationPropID, owlOntology, 0 ),
SPOA( individualID, annotationPropID, owlOntology, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlOntology, 0 ),
SPOA( annotationPropID, annotationPropID, owlOntology, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlOntology, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlOntology, 0 ),
SPOA( classID, annotationPropID, owlOntology, 0 ),
SPOA( dataPropID, annotationPropID, owlOntology, 0 ),
SPOA( objectPropID, annotationPropID, owlOntology, 0 ),
SPOA( transitivePropID, annotationPropID, owlOntology, 0 ),
SPOA( datatypeID, annotationPropID, owlOntology, 0 ),
SPOA( ontologyID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlOntologyProperty, 0 ),
SPOA( individualID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlOntologyProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( classID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlOntologyProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlRestriction, 0 ),
SPOA( unnamedOntology, annotationPropID, owlRestriction, 0 ),
SPOA( individualID, annotationPropID, owlRestriction, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlRestriction, 0 ),
SPOA( annotationPropID, annotationPropID, owlRestriction, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlRestriction, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlRestriction, 0 ),
SPOA( classID, annotationPropID, owlRestriction, 0 ),
SPOA( dataPropID, annotationPropID, owlRestriction, 0 ),
SPOA( objectPropID, annotationPropID, owlRestriction, 0 ),
SPOA( transitivePropID, annotationPropID, owlRestriction, 0 ),
SPOA( datatypeID, annotationPropID, owlRestriction, 0 ),
SPOA( ontologyID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( individualID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( classID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlSymmetricProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( individualID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( classID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlTransitiveProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( unnamedOntology, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( individualID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( annotationPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( classID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( dataPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( objectPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( transitivePropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( datatypeID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( ontologyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedOntology, annotationPropID, owlmaxCardinality, 0 ),
SPOA( individualID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlmaxCardinality, 0 ),
SPOA( annotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( classID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( objectPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( transitivePropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( datatypeID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyID, annotationPropID, owlcomplementOf, 0 ),
SPOA( unnamedOntology, annotationPropID, owlcomplementOf, 0 ),
SPOA( individualID, annotationPropID, owlcomplementOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlcomplementOf, 0 ),
SPOA( annotationPropID, annotationPropID, owlcomplementOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlcomplementOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlcomplementOf, 0 ),
SPOA( classID, annotationPropID, owlcomplementOf, 0 ),
SPOA( dataPropID, annotationPropID, owlcomplementOf, 0 ),
SPOA( objectPropID, annotationPropID, owlcomplementOf, 0 ),
SPOA( transitivePropID, annotationPropID, owlcomplementOf, 0 ),
SPOA( datatypeID, annotationPropID, owlcomplementOf, 0 ),
SPOA( ontologyID, annotationPropID, owldifferentFrom, 0 ),
SPOA( unnamedOntology, annotationPropID, owldifferentFrom, 0 ),
SPOA( individualID, annotationPropID, owldifferentFrom, 0 ),
SPOA( unnamedIndividual, annotationPropID, owldifferentFrom, 0 ),
SPOA( annotationPropID, annotationPropID, owldifferentFrom, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owldifferentFrom, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owldifferentFrom, 0 ),
SPOA( classID, annotationPropID, owldifferentFrom, 0 ),
SPOA( dataPropID, annotationPropID, owldifferentFrom, 0 ),
SPOA( objectPropID, annotationPropID, owldifferentFrom, 0 ),
SPOA( transitivePropID, annotationPropID, owldifferentFrom, 0 ),
SPOA( datatypeID, annotationPropID, owldifferentFrom, 0 ),
SPOA( ontologyID, annotationPropID, owldisjointWith, 0 ),
SPOA( unnamedOntology, annotationPropID, owldisjointWith, 0 ),
SPOA( individualID, annotationPropID, owldisjointWith, 0 ),
SPOA( unnamedIndividual, annotationPropID, owldisjointWith, 0 ),
SPOA( annotationPropID, annotationPropID, owldisjointWith, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owldisjointWith, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owldisjointWith, 0 ),
SPOA( classID, annotationPropID, owldisjointWith, 0 ),
SPOA( dataPropID, annotationPropID, owldisjointWith, 0 ),
SPOA( objectPropID, annotationPropID, owldisjointWith, 0 ),
SPOA( transitivePropID, annotationPropID, owldisjointWith, 0 ),
SPOA( datatypeID, annotationPropID, owldisjointWith, 0 ),
SPOA( ontologyID, annotationPropID, owldistinctMembers, 0 ),
SPOA( unnamedOntology, annotationPropID, owldistinctMembers, 0 ),
SPOA( individualID, annotationPropID, owldistinctMembers, 0 ),
SPOA( unnamedIndividual, annotationPropID, owldistinctMembers, 0 ),
SPOA( annotationPropID, annotationPropID, owldistinctMembers, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owldistinctMembers, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owldistinctMembers, 0 ),
SPOA( classID, annotationPropID, owldistinctMembers, 0 ),
SPOA( dataPropID, annotationPropID, owldistinctMembers, 0 ),
SPOA( objectPropID, annotationPropID, owldistinctMembers, 0 ),
SPOA( transitivePropID, annotationPropID, owldistinctMembers, 0 ),
SPOA( datatypeID, annotationPropID, owldistinctMembers, 0 ),
SPOA( ontologyID, annotationPropID, owlequivalentClass, 0 ),
SPOA( unnamedOntology, annotationPropID, owlequivalentClass, 0 ),
SPOA( individualID, annotationPropID, owlequivalentClass, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlequivalentClass, 0 ),
SPOA( annotationPropID, annotationPropID, owlequivalentClass, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlequivalentClass, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlequivalentClass, 0 ),
SPOA( classID, annotationPropID, owlequivalentClass, 0 ),
SPOA( dataPropID, annotationPropID, owlequivalentClass, 0 ),
SPOA( objectPropID, annotationPropID, owlequivalentClass, 0 ),
SPOA( transitivePropID, annotationPropID, owlequivalentClass, 0 ),
SPOA( datatypeID, annotationPropID, owlequivalentClass, 0 ),
SPOA( ontologyID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlequivalentProperty, 0 ),
SPOA( individualID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlequivalentProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( classID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlequivalentProperty, 0 ),
SPOA( ontologyID, annotationPropID, owlhasValue, 0 ),
SPOA( unnamedOntology, annotationPropID, owlhasValue, 0 ),
SPOA( individualID, annotationPropID, owlhasValue, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlhasValue, 0 ),
SPOA( annotationPropID, annotationPropID, owlhasValue, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlhasValue, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlhasValue, 0 ),
SPOA( classID, annotationPropID, owlhasValue, 0 ),
SPOA( dataPropID, annotationPropID, owlhasValue, 0 ),
SPOA( objectPropID, annotationPropID, owlhasValue, 0 ),
SPOA( transitivePropID, annotationPropID, owlhasValue, 0 ),
SPOA( datatypeID, annotationPropID, owlhasValue, 0 ),
SPOA( ontologyID, annotationPropID, owlintersectionOf, 0 ),
SPOA( unnamedOntology, annotationPropID, owlintersectionOf, 0 ),
SPOA( individualID, annotationPropID, owlintersectionOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlintersectionOf, 0 ),
SPOA( annotationPropID, annotationPropID, owlintersectionOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlintersectionOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlintersectionOf, 0 ),
SPOA( classID, annotationPropID, owlintersectionOf, 0 ),
SPOA( dataPropID, annotationPropID, owlintersectionOf, 0 ),
SPOA( objectPropID, annotationPropID, owlintersectionOf, 0 ),
SPOA( transitivePropID, annotationPropID, owlintersectionOf, 0 ),
SPOA( datatypeID, annotationPropID, owlintersectionOf, 0 ),
SPOA( ontologyID, annotationPropID, owlinverseOf, 0 ),
SPOA( unnamedOntology, annotationPropID, owlinverseOf, 0 ),
SPOA( individualID, annotationPropID, owlinverseOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlinverseOf, 0 ),
SPOA( annotationPropID, annotationPropID, owlinverseOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlinverseOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlinverseOf, 0 ),
SPOA( classID, annotationPropID, owlinverseOf, 0 ),
SPOA( dataPropID, annotationPropID, owlinverseOf, 0 ),
SPOA( objectPropID, annotationPropID, owlinverseOf, 0 ),
SPOA( transitivePropID, annotationPropID, owlinverseOf, 0 ),
SPOA( datatypeID, annotationPropID, owlinverseOf, 0 ),
SPOA( ontologyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedOntology, annotationPropID, owlmaxCardinality, 0 ),
SPOA( individualID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlmaxCardinality, 0 ),
SPOA( annotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( classID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( objectPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( transitivePropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( datatypeID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedOntology, annotationPropID, owlmaxCardinality, 0 ),
SPOA( individualID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlmaxCardinality, 0 ),
SPOA( annotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( classID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( dataPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( objectPropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( transitivePropID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( datatypeID, annotationPropID, owlmaxCardinality, 0 ),
SPOA( ontologyID, annotationPropID, owlonProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, owlonProperty, 0 ),
SPOA( individualID, annotationPropID, owlonProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlonProperty, 0 ),
SPOA( annotationPropID, annotationPropID, owlonProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlonProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlonProperty, 0 ),
SPOA( classID, annotationPropID, owlonProperty, 0 ),
SPOA( dataPropID, annotationPropID, owlonProperty, 0 ),
SPOA( objectPropID, annotationPropID, owlonProperty, 0 ),
SPOA( transitivePropID, annotationPropID, owlonProperty, 0 ),
SPOA( datatypeID, annotationPropID, owlonProperty, 0 ),
SPOA( ontologyID, annotationPropID, owloneOf, 0 ),
SPOA( unnamedOntology, annotationPropID, owloneOf, 0 ),
SPOA( individualID, annotationPropID, owloneOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, owloneOf, 0 ),
SPOA( annotationPropID, annotationPropID, owloneOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owloneOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owloneOf, 0 ),
SPOA( classID, annotationPropID, owloneOf, 0 ),
SPOA( dataPropID, annotationPropID, owloneOf, 0 ),
SPOA( objectPropID, annotationPropID, owloneOf, 0 ),
SPOA( transitivePropID, annotationPropID, owloneOf, 0 ),
SPOA( datatypeID, annotationPropID, owloneOf, 0 ),
SPOA( ontologyID, annotationPropID, owlsameAs, 0 ),
SPOA( unnamedOntology, annotationPropID, owlsameAs, 0 ),
SPOA( individualID, annotationPropID, owlsameAs, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlsameAs, 0 ),
SPOA( annotationPropID, annotationPropID, owlsameAs, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlsameAs, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlsameAs, 0 ),
SPOA( classID, annotationPropID, owlsameAs, 0 ),
SPOA( dataPropID, annotationPropID, owlsameAs, 0 ),
SPOA( objectPropID, annotationPropID, owlsameAs, 0 ),
SPOA( transitivePropID, annotationPropID, owlsameAs, 0 ),
SPOA( datatypeID, annotationPropID, owlsameAs, 0 ),
SPOA( ontologyID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( unnamedOntology, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( individualID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( annotationPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( classID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( dataPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( objectPropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( transitivePropID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( datatypeID, annotationPropID, owlsomeValuesFrom, 0 ),
SPOA( ontologyID, annotationPropID, owlunionOf, 0 ),
SPOA( unnamedOntology, annotationPropID, owlunionOf, 0 ),
SPOA( individualID, annotationPropID, owlunionOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, owlunionOf, 0 ),
SPOA( annotationPropID, annotationPropID, owlunionOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, owlunionOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, owlunionOf, 0 ),
SPOA( classID, annotationPropID, owlunionOf, 0 ),
SPOA( dataPropID, annotationPropID, owlunionOf, 0 ),
SPOA( objectPropID, annotationPropID, owlunionOf, 0 ),
SPOA( transitivePropID, annotationPropID, owlunionOf, 0 ),
SPOA( datatypeID, annotationPropID, owlunionOf, 0 ),
SPOA( ontologyID, annotationPropID, rdfList, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfList, 0 ),
SPOA( individualID, annotationPropID, rdfList, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfList, 0 ),
SPOA( annotationPropID, annotationPropID, rdfList, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfList, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfList, 0 ),
SPOA( classID, annotationPropID, rdfList, 0 ),
SPOA( dataPropID, annotationPropID, rdfList, 0 ),
SPOA( objectPropID, annotationPropID, rdfList, 0 ),
SPOA( transitivePropID, annotationPropID, rdfList, 0 ),
SPOA( datatypeID, annotationPropID, rdfList, 0 ),
SPOA( ontologyID, annotationPropID, rdfProperty, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfProperty, 0 ),
SPOA( individualID, annotationPropID, rdfProperty, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfProperty, 0 ),
SPOA( annotationPropID, annotationPropID, rdfProperty, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfProperty, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfProperty, 0 ),
SPOA( classID, annotationPropID, rdfProperty, 0 ),
SPOA( dataPropID, annotationPropID, rdfProperty, 0 ),
SPOA( objectPropID, annotationPropID, rdfProperty, 0 ),
SPOA( transitivePropID, annotationPropID, rdfProperty, 0 ),
SPOA( datatypeID, annotationPropID, rdfProperty, 0 ),
SPOA( ontologyID, annotationPropID, rdffirst, 0 ),
SPOA( unnamedOntology, annotationPropID, rdffirst, 0 ),
SPOA( individualID, annotationPropID, rdffirst, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdffirst, 0 ),
SPOA( annotationPropID, annotationPropID, rdffirst, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdffirst, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdffirst, 0 ),
SPOA( classID, annotationPropID, rdffirst, 0 ),
SPOA( dataPropID, annotationPropID, rdffirst, 0 ),
SPOA( objectPropID, annotationPropID, rdffirst, 0 ),
SPOA( transitivePropID, annotationPropID, rdffirst, 0 ),
SPOA( datatypeID, annotationPropID, rdffirst, 0 ),
SPOA( ontologyID, annotationPropID, rdfnil, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfnil, 0 ),
SPOA( individualID, annotationPropID, rdfnil, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfnil, 0 ),
SPOA( annotationPropID, annotationPropID, rdfnil, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfnil, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfnil, 0 ),
SPOA( classID, annotationPropID, rdfnil, 0 ),
SPOA( dataPropID, annotationPropID, rdfnil, 0 ),
SPOA( objectPropID, annotationPropID, rdfnil, 0 ),
SPOA( transitivePropID, annotationPropID, rdfnil, 0 ),
SPOA( datatypeID, annotationPropID, rdfnil, 0 ),
SPOA( ontologyID, annotationPropID, rdfrest, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfrest, 0 ),
SPOA( individualID, annotationPropID, rdfrest, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfrest, 0 ),
SPOA( annotationPropID, annotationPropID, rdfrest, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfrest, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfrest, 0 ),
SPOA( classID, annotationPropID, rdfrest, 0 ),
SPOA( dataPropID, annotationPropID, rdfrest, 0 ),
SPOA( objectPropID, annotationPropID, rdfrest, 0 ),
SPOA( transitivePropID, annotationPropID, rdfrest, 0 ),
SPOA( datatypeID, annotationPropID, rdfrest, 0 ),
SPOA( ontologyID, annotationPropID, rdftype, 0 ),
SPOA( unnamedOntology, annotationPropID, rdftype, 0 ),
SPOA( individualID, annotationPropID, rdftype, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdftype, 0 ),
SPOA( annotationPropID, annotationPropID, rdftype, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdftype, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdftype, 0 ),
SPOA( classID, annotationPropID, rdftype, 0 ),
SPOA( dataPropID, annotationPropID, rdftype, 0 ),
SPOA( objectPropID, annotationPropID, rdftype, 0 ),
SPOA( transitivePropID, annotationPropID, rdftype, 0 ),
SPOA( datatypeID, annotationPropID, rdftype, 0 ),
SPOA( ontologyID, annotationPropID, rdfsClass, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfsClass, 0 ),
SPOA( individualID, annotationPropID, rdfsClass, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfsClass, 0 ),
SPOA( annotationPropID, annotationPropID, rdfsClass, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfsClass, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfsClass, 0 ),
SPOA( classID, annotationPropID, rdfsClass, 0 ),
SPOA( dataPropID, annotationPropID, rdfsClass, 0 ),
SPOA( objectPropID, annotationPropID, rdfsClass, 0 ),
SPOA( transitivePropID, annotationPropID, rdfsClass, 0 ),
SPOA( datatypeID, annotationPropID, rdfsClass, 0 ),
SPOA( ontologyID, annotationPropID, rdfsDatatype, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfsDatatype, 0 ),
SPOA( individualID, annotationPropID, rdfsDatatype, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfsDatatype, 0 ),
SPOA( annotationPropID, annotationPropID, rdfsDatatype, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfsDatatype, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfsDatatype, 0 ),
SPOA( classID, annotationPropID, rdfsDatatype, 0 ),
SPOA( dataPropID, annotationPropID, rdfsDatatype, 0 ),
SPOA( objectPropID, annotationPropID, rdfsDatatype, 0 ),
SPOA( transitivePropID, annotationPropID, rdfsDatatype, 0 ),
SPOA( datatypeID, annotationPropID, rdfsDatatype, 0 ),
SPOA( ontologyID, annotationPropID, rdfsdomain, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfsdomain, 0 ),
SPOA( individualID, annotationPropID, rdfsdomain, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfsdomain, 0 ),
SPOA( annotationPropID, annotationPropID, rdfsdomain, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfsdomain, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfsdomain, 0 ),
SPOA( classID, annotationPropID, rdfsdomain, 0 ),
SPOA( dataPropID, annotationPropID, rdfsdomain, 0 ),
SPOA( objectPropID, annotationPropID, rdfsdomain, 0 ),
SPOA( transitivePropID, annotationPropID, rdfsdomain, 0 ),
SPOA( datatypeID, annotationPropID, rdfsdomain, 0 ),
SPOA( ontologyID, annotationPropID, rdfsrange, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfsrange, 0 ),
SPOA( individualID, annotationPropID, rdfsrange, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfsrange, 0 ),
SPOA( annotationPropID, annotationPropID, rdfsrange, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfsrange, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfsrange, 0 ),
SPOA( classID, annotationPropID, rdfsrange, 0 ),
SPOA( dataPropID, annotationPropID, rdfsrange, 0 ),
SPOA( objectPropID, annotationPropID, rdfsrange, 0 ),
SPOA( transitivePropID, annotationPropID, rdfsrange, 0 ),
SPOA( datatypeID, annotationPropID, rdfsrange, 0 ),
SPOA( ontologyID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfssubClassOf, 0 ),
SPOA( individualID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfssubClassOf, 0 ),
SPOA( annotationPropID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( classID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( dataPropID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( objectPropID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( transitivePropID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( datatypeID, annotationPropID, rdfssubClassOf, 0 ),
SPOA( ontologyID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( unnamedOntology, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( individualID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( unnamedIndividual, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( annotationPropID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( dataAnnotationPropID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( ontologyPropertyID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( classID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( dataPropID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( objectPropID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( transitivePropID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( datatypeID, annotationPropID, rdfssubPropertyOf, 0 ),
SPOA( restriction6subClassOf, owlhasValue, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlhasValue, liteInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlhasValue, userTypedLiteral, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlhasValue, literal, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlonProperty, dataPropID, 0|SecondOfTwo ),
SPOA( restriction6subClassOf, rdftype, owlRestriction, 0 ),
SPOA( restriction6equivalentClass, owlhasValue, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlhasValue, liteInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlhasValue, userTypedLiteral, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlhasValue, literal, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlonProperty, dataPropID, 0|SecondOfTwo ),
SPOA( restriction6equivalentClass, rdftype, owlRestriction, 0 ),
SPOA( restriction6disjointWith, owlhasValue, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlhasValue, liteInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlhasValue, userTypedLiteral, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlhasValue, literal, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlonProperty, dataPropID, 0|SecondOfTwo ),
SPOA( restriction6disjointWith, rdftype, owlRestriction, 0 ),
SPOA( restriction6object, owlhasValue, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlhasValue, liteInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlhasValue, userTypedLiteral, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlhasValue, literal, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlonProperty, dataPropID, 0|SecondOfTwo ),
SPOA( restriction6object, rdftype, owlRestriction, 0 ),
SPOA( restriction7subClassOf, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlonProperty, objectPropID, 0|SecondOfTwo ),
SPOA( restriction7subClassOf, rdftype, owlRestriction, 0 ),
SPOA( restriction7equivalentClass, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlonProperty, objectPropID, 0|SecondOfTwo ),
SPOA( restriction7equivalentClass, rdftype, owlRestriction, 0 ),
SPOA( restriction7disjointWith, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlonProperty, objectPropID, 0|SecondOfTwo ),
SPOA( restriction7disjointWith, rdftype, owlRestriction, 0 ),
SPOA( restriction7object, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction7object, owlonProperty, objectPropID, 0|SecondOfTwo ),
SPOA( restriction7object, rdftype, owlRestriction, 0 ),
SPOA( restriction8subClassOf, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlonProperty, transitivePropID, 0|SecondOfTwo ),
SPOA( restriction8subClassOf, rdftype, owlRestriction, 0 ),
SPOA( restriction8equivalentClass, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlonProperty, transitivePropID, 0|SecondOfTwo ),
SPOA( restriction8equivalentClass, rdftype, owlRestriction, 0 ),
SPOA( restriction8disjointWith, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlonProperty, transitivePropID, 0|SecondOfTwo ),
SPOA( restriction8disjointWith, rdftype, owlRestriction, 0 ),
SPOA( restriction8object, owlhasValue, individualID, 0|DL|FirstOfTwo ),
SPOA( restriction8object, owlonProperty, transitivePropID, 0|SecondOfTwo ),
SPOA( restriction8object, rdftype, owlRestriction, 0 ),
SPOA( description5subClassOf, owlintersectionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5subClassOf, rdftype, owlClass, 0|DL ),
SPOA( description5equivalentClass, owlintersectionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5equivalentClass, rdftype, owlClass, 0|DL ),
SPOA( description5disjointWith, owlintersectionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5disjointWith, rdftype, owlClass, 0|DL ),
SPOA( description5object, owlintersectionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5object, rdftype, owlClass, 0|DL ),
SPOA( description5subClassOf, owlunionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlunionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5disjointWith, owlunionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5object, owlunionOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, classID, 0|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, classID, 0|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, classID, 0|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, classID, 0|DL|FirstOfOne ),
SPOA( description5subClassOf, owloneOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5equivalentClass, owloneOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5disjointWith, owloneOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( description5object, owloneOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( unnamedDataRange, owloneOf, rdfnil, 0|DL|FirstOfOne ),
SPOA( unnamedDataRange, rdftype, owlDataRange, 0|DL ),
SPOA( listOfDataLiteral, rdffirst, dlInteger, 0|DL|FirstOfTwo ),
SPOA( listOfDataLiteral, rdffirst, liteInteger, 0|DL|FirstOfTwo ),
SPOA( listOfDataLiteral, rdffirst, userTypedLiteral, 0|DL|FirstOfTwo ),
SPOA( listOfDataLiteral, rdffirst, literal, 0|DL|FirstOfTwo ),
SPOA( listOfDataLiteral, rdfrest, rdfnil, 0|DL|SecondOfTwo ),
SPOA( listOfDataLiteral, rdftype, rdfList, 0|DL ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, dataRangeID, 0|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, datatypeID, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction6object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, dlInteger, 0|DL|FirstOfTwo ),
SPOA( restriction7object, owlmaxCardinality, liteInteger, 0|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, classID, 0|FirstOfTwo ),
SPOA( allDifferent, owldistinctMembers, rdfnil, 0|FirstOfOne ),
SPOA( allDifferent, rdftype, owlAllDifferent, 0 ),
SPOA( listOfDescription, rdffirst, classID, 0|FirstOfTwo ),
SPOA( listOfDescription, rdfrest, rdfnil, 0|SecondOfTwo ),
SPOA( listOfDescription, rdftype, rdfList, 0 ),
SPOA( listOfIndividualID, rdffirst, individualID, 0|FirstOfTwo ),
SPOA( listOfIndividualID, rdfrest, rdfnil, 0|SecondOfTwo ),
SPOA( listOfIndividualID, rdftype, rdfList, 0 ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( description5subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, classID, 0|SubjectAction|DL ),
SPOA( description5equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, classID, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, classID, 0|DL ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction8equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction6equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction7equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction8equivalentClass, 0 ),
SPOA( classID, owlequivalentClass, restriction8equivalentClass, 0 ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction6equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction7equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, restriction8equivalentClass, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction6disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction7disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, restriction8disjointWith, 0|DL ),
SPOA( classID, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( classID, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( classID, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( classID, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction6equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction7equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( restriction8equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( description5equivalentClass, owlequivalentClass, description5equivalentClass, 0|DL ),
SPOA( classID, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( classID, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction7disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction8disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( description5disjointWith, owldisjointWith, description5disjointWith, 0|DL ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction8subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction8disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction8object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction6disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction6object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction7subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction7disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction7object, rdftype, owlClass, 0 ),
SPOA( restriction8subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction8disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction8object, rdftype, owlClass, 0 ),
SPOA( restriction8subClassOf, rdftype, owlClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, owlClass, 0 ),
SPOA( restriction8disjointWith, rdftype, owlClass, 0 ),
SPOA( restriction8object, rdftype, owlClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction8subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction8disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction8object, rdftype, rdfsClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction6subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction6equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction6disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction6object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction7subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction7equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction7disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction7object, rdftype, rdfsClass, 0 ),
SPOA( restriction8subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction8disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction8object, rdftype, rdfsClass, 0 ),
SPOA( restriction8subClassOf, rdftype, rdfsClass, 0 ),
SPOA( restriction8equivalentClass, rdftype, rdfsClass, 0 ),
SPOA( restriction8disjointWith, rdftype, rdfsClass, 0 ),
SPOA( restriction8object, rdftype, rdfsClass, 0 ),
SPOA( description5subClassOf, rdftype, rdfsClass, 0|DL ),
SPOA( description5equivalentClass, rdftype, rdfsClass, 0|DL ),
SPOA( description5disjointWith, rdftype, rdfsClass, 0|DL ),
SPOA( description5object, rdftype, rdfsClass, 0|DL ),
SPOA( description5subClassOf, rdftype, rdfsClass, 0|DL ),
SPOA( description5equivalentClass, rdftype, rdfsClass, 0|DL ),
SPOA( description5disjointWith, rdftype, rdfsClass, 0|DL ),
SPOA( description5object, rdftype, rdfsClass, 0|DL ),
SPOA( description5subClassOf, rdftype, rdfsClass, 0|DL ),
SPOA( description5equivalentClass, rdftype, rdfsClass, 0|DL ),
SPOA( description5disjointWith, rdftype, rdfsClass, 0|DL ),
SPOA( description5object, rdftype, rdfsClass, 0|DL ),
SPOA( description5subClassOf, rdftype, rdfsClass, 0|DL ),
SPOA( description5equivalentClass, rdftype, rdfsClass, 0|DL ),
SPOA( description5disjointWith, rdftype, rdfsClass, 0|DL ),
SPOA( description5object, rdftype, rdfsClass, 0|DL ),
SPOA( unnamedDataRange, rdftype, rdfsClass, 0|DL ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction8object, ObjectAction ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction6object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction7object, ObjectAction ),
SPOA( individualID, rdftype, restriction8object, ObjectAction ),
SPOA( individualID, rdftype, restriction8object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction8object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction6object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction7object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction8object, ObjectAction ),
SPOA( unnamedIndividual, rdftype, restriction8object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction8object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction6object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction7object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction8object, ObjectAction ),
SPOA( classID, rdfssubClassOf, restriction8object, ObjectAction ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction8object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction6object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction7object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction8object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, restriction8object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction6object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction7object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, restriction8object, ObjectAction|DL ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction6object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction7object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, restriction8object, ObjectAction|DL|FirstOfOne ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction6object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction7object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, restriction8object, ObjectAction|DL|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction8object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction6object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction7object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction8object, ObjectAction|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, restriction8object, ObjectAction|FirstOfTwo ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction6object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction7object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, restriction8object, ObjectAction|SubjectAction|DL ),
SPOA( classID, owlcomplementOf, description5object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, description5object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, description5object, ObjectAction|DL ),
SPOA( classID, owlcomplementOf, description5object, ObjectAction|DL ),
SPOA( classID, rdfssubClassOf, description5object, ObjectAction|DL ),
SPOA( classID, rdfssubClassOf, description5object, ObjectAction|DL ),
SPOA( classID, rdfssubClassOf, description5object, ObjectAction|DL ),
SPOA( classID, rdfssubClassOf, description5object, ObjectAction|DL ),
SPOA( individualID, rdftype, description5object, ObjectAction|DL ),
SPOA( individualID, rdftype, description5object, ObjectAction|DL ),
SPOA( individualID, rdftype, description5object, ObjectAction|DL ),
SPOA( individualID, rdftype, description5object, ObjectAction|DL ),
SPOA( unnamedIndividual, rdftype, description5object, ObjectAction|DL ),
SPOA( unnamedIndividual, rdftype, description5object, ObjectAction|DL ),
SPOA( unnamedIndividual, rdftype, description5object, ObjectAction|DL ),
SPOA( unnamedIndividual, rdftype, description5object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( dataPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( objectPropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsdomain, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( transitivePropID, rdfsrange, description5object, ObjectAction|DL ),
SPOA( description5subClassOf, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlcomplementOf, description5object, ObjectAction|DL|FirstOfOne ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction7object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8subClassOf, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8equivalentClass, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8disjointWith, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction8object, owlsomeValuesFrom, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( listOfDescription, rdffirst, description5object, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction6subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction7subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( restriction8subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( description5subClassOf, rdfssubClassOf, description5object, ObjectAction|SubjectAction|DL ),
SPOA( dataPropID, rdfsrange, unnamedDataRange, ObjectAction|DL ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6subClassOf, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6equivalentClass, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6disjointWith, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( restriction6object, owlsomeValuesFrom, unnamedDataRange, ObjectAction|DL|FirstOfTwo ),
SPOA( unnamedDataRange, owloneOf, listOfDataLiteral, ObjectAction|DL|FirstOfOne ),
SPOA( listOfDataLiteral, rdfrest, listOfDataLiteral, ObjectAction|DL|SecondOfTwo ),
SPOA( classID, owlintersectionOf, listOfDescription, ObjectAction ),
SPOA( classID, owlunionOf, listOfDescription, ObjectAction|DL ),
SPOA( description5subClassOf, owlintersectionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlintersectionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlintersectionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlintersectionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5subClassOf, owlunionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owlunionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owlunionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owlunionOf, listOfDescription, ObjectAction|DL|FirstOfOne ),
SPOA( listOfDescription, rdfrest, listOfDescription, ObjectAction|SecondOfTwo ),
SPOA( classID, owloneOf, listOfIndividualID, ObjectAction|DL ),
SPOA( description5subClassOf, owloneOf, listOfIndividualID, ObjectAction|DL|FirstOfOne ),
SPOA( description5equivalentClass, owloneOf, listOfIndividualID, ObjectAction|DL|FirstOfOne ),
SPOA( description5disjointWith, owloneOf, listOfIndividualID, ObjectAction|DL|FirstOfOne ),
SPOA( description5object, owloneOf, listOfIndividualID, ObjectAction|DL|FirstOfOne ),
SPOA( allDifferent, owldistinctMembers, listOfIndividualID, ObjectAction|FirstOfOne ),
SPOA( listOfIndividualID, rdfrest, listOfIndividualID, ObjectAction|SecondOfTwo ),
};
static { Arrays.sort(triples); }
static final int userID = CategorySet.find( userIDX,false);
static final int propertyOnly = CategorySet.find( propertyOnlyX,false);
static final int classOnly = CategorySet.find( classOnlyX,false);
static final int blank = CategorySet.find( blankX,false);
static final int restrictions = CategorySet.find( restrictionsX,false);
static final int descriptions = CategorySet.find( descriptionsX,false);
static final int lists = CategorySet.find( listsX,false);
static final int disjointWith = CategorySet.find( disjointWithX,false);
 static boolean isPseudoCategory(int x) {
     switch ( x ) {
      case orphan:
      case notype:
      case cyclicRest:
      case cyclicFirst:
      case badRestriction:
        return true;
      default:
        return false;
     }
  }
}
 /*
 *	(c) Copyright 2003 Hewlett-Packard Development Company, LP
	All rights reserved.
 
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:
 
	1. Redistributions of source code must retain the above copyright
	   notice, this list of conditions and the following disclaimer.
 
	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.
 
	3. The name of the author may not be used to endorse or promote products
	   derived from this software without specific prior written permission.
 
	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS' AND ANY EXPRESS OR
	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/  
